package org.apache.maven.javacc;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import junit.framework.TestCase;

import java.io.File;
import java.util.Arrays;
import java.util.List;

import org.codehaus.plexus.util.FileUtils;

/**
 * 
 * @author <a href="michal.maczka@dimatics.com">Michal Maczka</a> 
 * @version $Id$
 */
public class JavaccBeanTest extends TestCase
{
    public void testGenerate()
    {
        
        final String basedir = System.getProperty( "basedir" );
        
        final File grammarFile = new File( basedir, "src/test-data/JavaCCSample.jj" );
                
        final File headerFile = new File( basedir, "src/test-data/JavaCCSample.jj.header" );
        
        final JavaccBean bean = new JavaccBean();
        
        bean.setGrammar( grammarFile.getAbsolutePath() );
        
        bean.setHeader( headerFile.getAbsolutePath() );
        
        final String fs = File.separator;
        
        final String gsd = basedir + fs +  "target" + fs + "generated-src" + fs + "main" + fs +  "java" ; 
        
        bean.setGeneratedSourceDirectory( gsd );
        
        final String packageName = "org.apache.maven.javacc.javacc";       
        
        bean.setJavaccPackageName( packageName );        
        
        try
        {
            FileUtils.deleteDirectory( bean.getJavaccOutputDir() );
            
            bean.generate();
            
        } 
        catch ( Exception e )
        {
            e.printStackTrace();
            
            fail( "Generation failed" );
            
        }
        final String[] fileNames = bean.getJavaccOutputDir().list();        
        
        final List list = Arrays.asList( fileNames );
        
        assertTrue( list.contains( "Simple1.java" ));
        
        assertTrue( list.contains( "Token.java" ));


    }


}
